/* Copyright 2013 NuoDB, Inc. All rights reserved */
#pragma once

namespace NuoDB
{
class ResultSet;

static const int RESULTLIST_VERSION     = 1;

/*
 * Not yet implemented...
 */
class ResultList
{
protected:
    virtual ~ResultList() {}

public:
    /**
     * @brief   Increment the reference count for this object
     */
    virtual void    addRef() = 0;

    /**
     * @brief   Decrement the reference count for this object and if the 
     *          reference count is 0, delete the object
     *
     * @return  the reference count for this object; 0 if the object was deleted
     */
    virtual int     release() = 0;

    virtual const char* getTableName() = 0;
    virtual double      getScore() = 0;
    virtual int         getCount() = 0;
    virtual ResultSet*  fetchRecord() = 0;
    virtual bool        next() = 0;
    virtual void        close() = 0;
    virtual int         objectVersion() = 0;
};
}                   // end namespace NuoDB
